diff --git a/lib.c b/lib.c
index 86d12f615e8..acf835f787c 100644
--- a/lib.c
+++ b/lib.c
@@ -1128,7 +1128,8 @@ int mutt_same_path (const char *a, const char *b)
 
   /* Compare the paths */
   size_t a_len = a_end - a;
-  return ((a_len == (b_end - b)) && (mutt_strncasecmp (a, b, a_len) == 0));
+  size_t b_len = b_end - b;
+  return mutt_strncasecmp (a, b, a_len < b_len ? a_len : b_len) == 0;
 }
 
 char * strfcpy (char *dest, const char *src, size_t dlen)
